#pragma once

typedef unsigned short PIXEL16;
typedef unsigned long PIXEL32;
typedef PIXEL16 PIXELZ16;
typedef PIXEL16 PIXEL565;
typedef PIXEL16 PIXEL555;
typedef PIXEL16 PIXEL4444;
typedef PIXEL32 PIXELZ32;
typedef PIXEL32 PIXEL8888;
typedef short SCALAR16;
typedef long SCALAR32;
#define PIXELZ16_BITS					16
#define PIXEL565_BITS					16
#define PIXEL555_BITS					16
#define PIXEL4444_BITS					16
#define PIXELZ32_BITS					32
#define PIXEL8888_BITS					32
#define SCALAR32_MAXZ16					65536
#define SCALAR32_POINT					8
#define SCALAR32_UNIT					(1 << SCALAR32_POINT)
#define SCALAR32_PI						804
#define SCALAR32_TO_LONG(x)				((x) >> SCALAR32_POINT)
#define LONG_TO_SCALAR32(x)				((x) << SCALAR32_POINT)
#define SCALAR32_MUL(x, y)				(((x) * (y)) >> SCALAR32_POINT)
#define SCALAR32_DIV(x, y)				(((x) << SCALAR32_POINT) / (y))
#define VERTEX_CULL_NONE				0
#define VERTEX_CULL_LEFT				1
#define VERTEX_CULL_RIGHT				2

struct MATRIX_XYZW
{
	SCALAR32 m[4][4];
};

struct BITMAP16ANY
{
	PIXEL16* pBitmap;
	SCALAR16 Width;
	SCALAR16 Height;
	SCALAR16 MaskX;
	SCALAR16 MaskY;
	SCALAR16 ShiftX;
	SCALAR16 ShiftY;
};

struct BITMAPZ16 : public BITMAP16ANY
{
};

struct BITMAP565 : public BITMAP16ANY
{
};

struct VERTEX_XY
{
	SCALAR32 x;
	SCALAR32 y;
};

struct VERTEX_XYUV
{
	SCALAR32 x;
	SCALAR32 y;
	SCALAR32 u;
	SCALAR32 v;
};

struct VERTEX_XYZWUV
{
	SCALAR32 x;
	SCALAR32 y;
	SCALAR32 z;
	SCALAR32 w;
	SCALAR32 u;
	SCALAR32 v;
};

SCALAR32 Scalar32Sin(SCALAR32 x);
SCALAR32 Scalar32Cos(SCALAR32 x);
void DivideVertexByW(VERTEX_XYZWUV* pVertex);
VERTEX_XYZWUV MultiplyMatrixVertex(MATRIX_XYZW* pMatrix, VERTEX_XYZWUV* pVertex);
MATRIX_XYZW GetZeroMatrix();
MATRIX_XYZW GetIdentityMatrix();
MATRIX_XYZW MultiplyMatrix(MATRIX_XYZW* pMatrix1, MATRIX_XYZW* pMatrix2);
MATRIX_XYZW GetMoveMatrix(SCALAR32 x, SCALAR32 y, SCALAR32 z);
MATRIX_XYZW GetRotateXMatrix(SCALAR32 Theta);
MATRIX_XYZW GetRotateYMatrix(SCALAR32 Theta);
MATRIX_XYZW GetRotateZMatrix(SCALAR32 Theta);
MATRIX_XYZW GetViewAngleMatrix(SCALAR32 Angle, SCALAR16 Width, SCALAR16 Height, SCALAR32 Near, SCALAR32 Far);
BOOL CreateBitmap16Any(BITMAP16ANY* pBitmap, LONG Width, LONG Height);
void DestroyBitmap16Any(BITMAP16ANY* pBitmap);
void DrawVertexXY(BITMAP565* pOut, VERTEX_XY* p1, VERTEX_XY* p2, VERTEX_XY* p3);
void DrawVertexXYUV(BITMAP565* pOut, BITMAP565* pTexture, VERTEX_XYUV* p1, VERTEX_XYUV* p2, VERTEX_XYUV* p3);
void DrawVertexXYZWUV(BITMAP565* pOut, BITMAPZ16* pZBuffer, BITMAP565* pTexture, VERTEX_XYZWUV* p1, VERTEX_XYZWUV* p2, VERTEX_XYZWUV* p3);
void DrawVertexArrayXY(BITMAP565* pOut, VERTEX_XY* pData, DWORD Count, DWORD CullMode);
void DrawVertexArrayXYUV(BITMAP565* pOut, BITMAP565* pTexture, VERTEX_XYUV* pData, DWORD Count, DWORD CullMode);
void DrawVertexArrayXYZWUV(BITMAP565* pOut, BITMAPZ16* pZBuffer, BITMAP565* pTexture, VERTEX_XYZWUV* pData, DWORD Count, DWORD CullMode);

